#<Safemode::ScopeObject>@
Description

1. use <%= host_params('blabla') %> inside the host parameters

2. Rendering fails on Safemode doesn't allow to access 'host_params' on #<Safemode::ScopeObject>

Related issues:

Related to Foreman - Feature #16740: Host parameters should be available in t... Closed 09/29/2016

Related to Foreman - Bug #23593: function "host_param" in default value of sm... Duplicate

Associated revisions

Revision 638d98a9 - 01/08/2018 12:20 PM - Ivan Necas

Fixes #20931 - unify parameters and templates renderer (#4835)

Fixes #20931 - unify parameters and templates renderer

Before this patch, we used separate renderer for the parameters. This

caused issues when introducing more dsl methods for the templates that

we want to use in the parameters as well. Also, by the time of writing

the original SafeRenderer, there was no Renderer available.

After doing so, I was hitting issue with recursion, as

`Renderer.host_param` was using `@host.params` while the @host.params

was trying to render the params, that could include the `host_param`

call again, which lead to endless loop. After simplifying the

`HostParams` methods, it is possible to achieve this.

I also noticed that we were rendering only the inherited params and not

the non-inherited once. I've fixed this bug also as part of this patch.

Last but not least, due to the fact that we were using the

host_inherited_params for multiple purposes, we were rendering it also

when showing the host form, which was not even needed.

History

#1 - 09/14/2017 10:03 AM - Ivan Necas

- Related to Feature #16740: Host parameters should be available in templates using some macro added

#2 - 09/14/2017 02:42 PM - Ivan Necas

- Difficulty changed from easy to medium

#3 - 09/14/2017 02:54 PM - The Foreman Bot

- Status changed from Assigned to Ready For Testing

- Pull request https://github.com/theforeman/foreman/pull/4835 added
#4 - 01/08/2018 12:21 PM - Marek Hulán

- translation missing: en.field_release set to 330

#5 - 01/08/2018 01:02 PM - Ivan Necas

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset 638d98a90b848bfa9a6f0e722b2cbc992caaef34.

#6 - 06/01/2018 12:45 PM - Marek Hulán

- Related to Bug #23593: function "host_param" in default value of smart class parameter is not allowed anymore. It results in undefined method

`host_param' (erb):1:in `parse_string' added

#7 - 09/03/2018 10:29 AM - Ondřej Pražák

- Triaged set to No

- Fixed in Releases 1.18.2 added

#8 - 09/05/2018 12:35 PM - Tomer Brisker

- Fixed in Releases 1.18.0 added

- Fixed in Releases deleted (1.18.2)
